EXPORT ISDEBCOM
EXPORT ISENDCOM
EXPORT ISDEBSTRING
EXPORT ISENDSTRING
EXPORT FAST_CHARCPY

;---------------------------- FAST_CHARCPY ------------------------
;ACTION: Copie une chaine dans dst sans mettre le zero de fin
;        ou il est mis un espace
;RETOUR: D0 pointe apres l'espace mis
FAST_CHARCPY:
   move.b (a0)+,(a1)+
   bne.b FAST_CHARCPY
   move.b #' ', -1(a1)
   move.l a1,d0
   rts
   

;---------------------------- ISENDCOM --------------------------
;ACTION: teste si le caractre point est une fin de commentaire
;        CAD "*/x" avec x different de "/"
;ENTREE A0  pointe sur le texte a verifier.
;SORTIE D0  1 A0 pointe une fin de commentaire 
;           0 A0 pointe pas une fin de commentaire 
ISENDCOM:
   ;move.l A0,-(a7)
   moveq #0,d0
   cmp.b #'*',(a0)+
   bne pas_end_comment
   cmp.b #'/',(a0)+
   bne pas_end_comment
   cmp.b #'/',(a0)
   beq pas_end_comment
      moveq #1,d0
   pas_end_comment:
   ;move.l (a7)+,A0
   rts
 
;---------------------------- ISDEBCOM --------------------------
;ACTION: teste si le caractre point est un debut de commentaire
;ENTREE A0  pointe sur le texte a verifier.
;SORTIE D0  1 A0 pointe une fin de commentaire 
;           0 A0 pointe pas une fin de commentaire 
ISDEBCOM:
   moveq #0,d0
   cmp.b #'/',(a0)+
   bne pas_deb_comment
   cmp.b #'*',(a0)
   bne pas_deb_comment
      moveq #1,d0
   pas_deb_comment:
   rts
;---------------------------- ISDEBSTRING --------------------------
;ACTION: teste si le caractre point est un debut de chaine
;        CAD  x"  avec x different de \'
;ENTREE A0  pointe sur le texte a verifier.
;SORTIE D0  1 A0 pointe une fin de commentaire 
;           0 A0 pointe pas une fin de commentaire 
ISDEBSTRING:
   ;move.l A0,-(a7)
   moveq #0,d0
   cmp.b #'"',(a0)
   bne pas_deb_string
   cmp.b #'\',-1(a0)       ; \
   beq pas_deb_string
   cmp.b #39,-1(a0)        ; '
   beq pas_deb_string
      moveq #1,d0
   pas_deb_string:
   ;move.l (a7)+,A0
   rts

;---------------------------- ISENDSTRING --------------------------
;ACTION: teste si le caractre point est une fin de chaine
;        CAD  x"  avec x different de \' et pas \\"
;ENTREE A0  pointe sur le texte a verifier.
;SORTIE D0  1 A0 pointe une fin de commentaire 
;           0 A0 pointe pas une fin de commentaire 
ISENDSTRING:
   moveq #0,d0
   cmp.b #'"',(a0)
   bne pas_end_string
   
   ;cmp.b #39,-1(a0)        ; '
   ;beq pas_end_string
   
   cmp.b #'\',-1(a0)        ; \
   beq test_end_string
      
      moveq #1,d0
 pas_end_string:
   rts
   
test_end_string:
   move.l A1,-(A7)
   move.l a0, a1
   
bcle_test_end_string:        ;decremente a1 tant qu'il pointe sur \ (donc si \\ -> impair)
   SUB #1,A1
   CMP.B #'\',(a1)           ;                                      (donc si \\\ ->pair)
   beq bcle_test_end_string
   sub.l a1,a0
   move.l a0,d0
   AND.L #$00000001,d0
   move.l(a7)+,a1
   rts
   
  DATA
  
TypeVarC:  
 dc.b  0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0 
 dc.b  0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,0  ,0  ,0  ,0  ,0  ,0 
 dc.b  0  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,0  ,0  ,0  ,0  ,1 
 dc.b  0  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,0  ,0  ,0  ,0  ,0 
 dc.b  0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0 
 dc.b  0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0 
 dc.b  0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0 
 dc.b  0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0 
 
