/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\   CONFIG.C    \\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/* Ce module est un des sources C de : PCSTUDIO.PRG                    */
/* Le fichier projet associ est:      PCSTUDIO.PRJ                    */
/* Gestion des options de configuration:                               */
/*                  du Linker, du compilateur et de l'assembleeur      */
/* Quelques options de GCCShell sont aussi positionnes:               */
/*          Strip after link et memoire Mint                           */
/*                                                                     */

 
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*--------------------- INCLUDES DES AUTRES MODULES DU PROGRAMME -------*/
#include <EAZY_GEM.H>  /* inclure les definitions des fonctions que le  */

/*--------------------- INCLURE LES DEFINITIONS SYMBOLIQUES ------------*/
/*                      que l'diteur de ressource gnre               */
/*                      lors de la cration de la ressource             */
#include "PCSTUDIO.SYS\CONFIG.H"
#include "PCSTUDIO.SYS\PCSTUDIO.H"
#include "PCSTUDIO.SYS\P2IMESSG.H"
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                         TYPAGE DES FENETRES                          */
/*----------------------------------------------------------------------*/
 
#define W_PCSTUDIO    1     /* (identificateur ou type) de la Fenetre   */
#define W_CONFIG      2     /* (identificateur ou type) de la Fenetre   */
#define W_PEXEC3      3     /* (identificateur ou type) de la Fenetre   */
#define W_WINDLIST    4     /* (identificateur ou type) de la Fenetre   */

#define WM_UPDATE_CFG (WM_USER+123)

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
extern char **TxtPtStrMess;
extern char SharedTxt;
extern char MemMode;
extern char AutoError;
extern char OptCompil[256];
extern char OptAssemb[256];
extern char OptLinker[256];
extern char PathInclude[256];
extern char PathLib[256];
extern char PathProject[256];
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*................ FONCTIONs DU FICHIER ACTUEL .........................*/
void OptionCompilToDialog(INT16 w_ind, OBJECT *object, char *options, INT16 redraw_flag);
void OptionAsemblToDialog(INT16 w_ind, OBJECT *object, char *options, INT16 redraw_flag);
void OptionLinkerToDialog(INT16 w_ind, OBJECT *object, char *options, INT16 redraw_flag);
void DialogToLinkerParam(OBJECT *object,  char *option);
void DialogToCompilParam(OBJECT *object,  char *option);
void DialogToAsemblParam(OBJECT *object,  char *option);
/*................ FONCTIONS CALLBACK DE FENETRES ......................*/
 CALLBACK WindProcCONFIG(INT16 w_ind, EVNT_O *Evnt);
/*................ FONCTIONs DU FICHIER: PCSTUDIO.C ....................*/
extern void SaveDefConf(INT16 w_ind);
extern char CleanArg(char *pt);

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*------------------------------ WindProcCONFIG ---------------------------*/
CALLBACK WindProcCONFIG(INT16 w_ind, EVNT_O *Evnt)
{/*....recuperer l'adresse du premier objet (racine) de la ressource....*/          
 OBJECT *object = GETWINDTREE(w_ind);
 INT16        w_h = GETGEMHAND(w_ind);
 INT16     wh_top = GetTopWind();  /* handle fenetre en avant plan         */

 /*............................Rpondre  l'vnement MU_KEYBD .........*/
 if (Evnt->evnt & MU_KEYBD && w_h == wh_top)
    {INT16 ob_edit = GETOBJCEDIT(w_ind);
     if (w_h == wh_top ) Xform_keybd(w_ind, Evnt);
     /*........ selon texte saisi (onglet actif) .......................*/
     /*         mettre  jour en temps reel les paramtres              */
     /*         et la ligne d'options du dialogue principal             */
     /*         allant avec                                             */
     if (ob_edit >= TEXTE_SEG_TXT && ob_edit<= HEAP_SIZE_TXT)
        {DialogToLinkerParam(object,  OptLinker);
        }
     else if (ob_edit >= NBR_ERREURS_TXT && ob_edit<= OUT_COMPIL_TXT)
        {DialogToCompilParam(object,  OptCompil);
        }
     else if(ob_edit >= MACRO_ASM_TXT && ob_edit<= INCLUDE_ASM_TXT)
        {DialogToAsemblParam(object,  OptAssemb);
        }
    }
    
 /*.......................... Rpondre  l'vnement MU_BUTTON .........*/ 
 if (Evnt->evnt & MU_BUTTON)
    {INT16 ob_ret = Xform_button(w_ind, Evnt); /* recuperer objet clique */    
     if (ob_ret>-1)            /*<<<<SI UN OBJET EST CLIQUE >>>>>>>>>>>*/
        {Evnt->evnt &= ~MU_BUTTON;  
         /*.............. ICI ACTION SELON BOUTON CLIQUE..............*/
         if (ob_ret>=CHK_LNKADDGLOBAL    && ob_ret<=CHK_SHARED_TXT)
            {DialogToLinkerParam(object,  OptLinker);
            }
         else if (ob_ret>=CHK_ANSI_KEYW  && ob_ret<=CHK_COPRO_CODE)
            {DialogToCompilParam(object,  OptCompil);
            }
         else if (ob_ret>=CHK_MC68010    && ob_ret<=CHK_NOOUTPUTMESS)
            {DialogToAsemblParam(object,  OptAssemb);
            }
         else if (ob_ret>=RAD_MEMPROTECT && ob_ret<=RAD_READONLY)
            {DialogToLinkerParam(object,  OptLinker);
            }
         else
            {char path[256];
             char nom[128];
             switch (ob_ret)
              {case DEBUG_LNK_BUT:
                    object[CHK_LNKADDGLOBAL].ob_state |=  SELECTED;
                    object[CHK_LNK_ADDLOCAL].ob_state |=  SELECTED;
                    object[CHK_LNK_ADDDEBUG].ob_state |=  SELECTED;
                    Wobjc_draw(w_ind, object, CHK_LNKADDGLOBAL, 1, 0);
                    Wobjc_draw(w_ind, object, CHK_LNK_ADDLOCAL, 1, 0);
                    Wobjc_draw(w_ind, object, CHK_LNK_ADDDEBUG, 1, 0);
                    DialogToLinkerParam(object,  OptLinker);
                    object[ob_ret].ob_state &= ~SELECTED;
                    Wobjc_draw(w_ind, object, ob_ret, 1, 0);
                    break;
               case RELEASE_LNK_BUT:
                    object[CHK_LNKADDGLOBAL].ob_state &= ~SELECTED;
                    object[CHK_LNK_ADDLOCAL].ob_state &= ~SELECTED;
                    object[CHK_LNK_ADDDEBUG].ob_state &= ~SELECTED;
                    Wobjc_draw(w_ind, object, CHK_LNKADDGLOBAL, 1, 0);
                    Wobjc_draw(w_ind, object, CHK_LNK_ADDLOCAL, 1, 0);
                    Wobjc_draw(w_ind, object, CHK_LNK_ADDDEBUG, 1, 0);
                    DialogToLinkerParam(object,  OptLinker);
                    object[ob_ret].ob_state &= ~SELECTED;
                    Wobjc_draw(w_ind, object, ob_ret, 1, 0);
                    break;
               case OUT_COMPIL_BUT:
                    strcpy(nom,"*.*");
                    strcpy(path, PathProject);
                    PathNomToNomFic(path,0) ;
                    if (FileSelect (path, nom, ".*", TxtPtStrMess[MESS_FS_OUTPUT])!= -2)
                       {ObjcSetTxt(object, OUT_COMPIL_TXT, path);
                        DialogToCompilParam(object,  OptCompil);
                        Wobjc_draw(w_ind, object, OUT_COMPIL_TXT, 1, 0);
                       }
                    object[ob_ret].ob_state &= ~SELECTED;
                    Wobjc_draw(w_ind, object, ob_ret, 1, 0);
                    break;
               case OUT_DIRASM_BUT:
                    strcpy(nom,"*.*");
                    strcpy(path, PathProject);
                    PathNomToNomFic(path,0) ;
                    if (FileSelect (path, nom, ".*", TxtPtStrMess[MESS_FS_OUTPUT])!= -2)
                       {ObjcSetTxt(object, OUTPUT_ASM_TXT, path);
                        DialogToAsemblParam(object,  OptAssemb);
                        Wobjc_draw(w_ind, object, OUTPUT_ASM_TXT, 1, 0);
                       }
                    object[ob_ret].ob_state &= ~SELECTED;
                    Wobjc_draw(w_ind, object, ob_ret, 1, 0);
                    break;
               case INCLASM_DIR_BUT:
                    strcpy(nom,"*.*");
                    strcpy(path, PathInclude);
                    PathNomToNomFic(path,0) ;
                    if (FileSelect (path, nom, ".*", TxtPtStrMess[MESS_FS_ASM_INCL])!= -2)
                       {ObjcSetTxt(object, INCLUDE_ASM_TXT, path);
                        DialogToAsemblParam(object,  OptAssemb);
                        Wobjc_draw(w_ind, object, INCLUDE_ASM_TXT, 1, 0);
                       }
                    object[ob_ret].ob_state &= ~SELECTED;
                    Wobjc_draw(w_ind, object, ob_ret, 1, 0);
                    break;
              } /* endswitch (ob_ret)      */
            } /* endelse */
        }  /* endif objet selectable cliqu  */ 
    } /* endif MU_BUTTON  et fenetre au premier plan */
 
 /*.......................... Rpondre  l'vnement MU_TIMER.............*/
 if (Evnt->evnt & MU_TIMER && w_h == wh_top)  Xform_timer(w_ind, Evnt);    
   
 /*..........................Rpondre  l'vnement MU_MOVE ..............*/
 if (Evnt->evnt & MU_MOVE)                    Xform_mu_move(w_ind, Evnt);
    
 /*..........................Rpondre aux messages MU_MESAG ..............*/
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {case WM_CONSTRUCT:
            {INT16 ong_to_set, i;
             if (WindDialogConstruct(w_ind, 
                                     LoadAppliRsc( "CONFIG.RSC", NO_SCALE), 0, RSC_DIAL, Evnt
                                    ) == WM_ABORT
                ) return WM_ABORT;
             /*........ activation du bon onglet .........*/
             switch((INT16)Windtab[w_ind].UserPtr)
               {case 0: ong_to_set = ONG_COMPIL;  break;
                case 1: ong_to_set = ONG_ASSEMBL; break;
                case 2: ong_to_set = ONG_LINK;    break;
               }
             object = GETWINDTREE(w_ind);
             /*.......... initialiser les textes sur zero .................*/
             for (i = TEXTE_SEG_TXT; i<= HEAP_SIZE_TXT; i++)
                 {ObjcSetTxt(object, i, "");
                 }
             for (i = NBR_ERREURS_TXT; i<= OUT_COMPIL_TXT; i++)
                 {ObjcSetTxt(object, i, "");
                 }
             for (i=MACRO_ASM_TXT; i<=INCLUDE_ASM_TXT; i++)
                 {ObjcSetTxt(object, i, "");
                 }
             ActiveOnglet(w_ind, ONGLET_CONTAIN, ong_to_set);
             /*........... placer le tout sous la souris ..................*/
             AdjustWindCoordToScreen (w_ind, Evnt, (GRECT*)&Evnt->pipe[X_B]);
             OptionCompilToDialog(w_ind, object, OptCompil, 0);
             OptionAsemblToDialog(w_ind, object, OptAssemb, 0);
             OptionLinkerToDialog(w_ind, object, OptLinker, 0);
            }
             break;
             
        case WM_UPDATE_CFG:
             switch(Evnt->pipe[WHND])
               {case 0:
                     OptionCompilToDialog(w_ind, object, OptCompil, !(object[ONG_COMPIL].ob_flags   & HIDETREE));
                     break;
                case 1:
                     OptionAsemblToDialog(w_ind, object, OptAssemb, !(object[ONG_ASSEMBL].ob_flags  & HIDETREE));
                     break;
                case 2:
                     OptionLinkerToDialog(w_ind, object, OptLinker, !(object[ONG_LINK].ob_flags     & HIDETREE));
                     break;
               } /* endswitch(Evnt->pipe[WHND]) */
             break;
             
        case WM_DESTRUCT:       /*  (EZGEM message)   */
             Xform_Destruct(w_ind, Evnt);    
             RscFicUnLoad(Windtab[w_ind].DlgVar.AdrRsc);
             break;   
        case WM_REDRAW: Lister_rectangles(w_h,(GRECT*)&Evnt->pipe[X_G]);      break;
        case WM_TT_ON_OFF:    SetBulleState(w_h, object);                     break;
        case WM_BOTTOM:       wind_set(w_h, WF_BOTTOM ,0,0,0,0);                      break;
        case WM_TOPPED:       wind_set(w_h, WF_TOP ,0,0,0,0);                         break;
        case WM_CLOSED:       DestroyWindow(w_h);                             break;
        case WM_ALLICONIFY:   AllIconify((GRECT*)&Evnt->pipe[X_G]);           break;
        case WM_ICONIFY:      IconifyWindow(w_ind, (GRECT*)&Evnt->pipe[X_G]); break;
        case WM_UNICONIFY:    UnconifyWindow(w_ind);                          break;
        case WM_MOVED:        OnWm_moved(w_ind, Evnt);                        break;
       } /* end switch message     */
    } /* end if Evnt & MU_MESSAG  */      
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}

/*----------------------- DialogToLinkerParam -----------------------------*/
void DialogToLinkerParam(OBJECT *object,  char *option)
{INT16 i;
 char *pt       = option;
 INT16  wind_targ = IdentToIndice(W_PCSTUDIO);
 char *txt      = 0;
 *pt   = 0; 
 for (i=CHK_LNKADDGLOBAL; i<=CHK_LNK_NOOUTPUT; i++)
     {if (object[i].ob_state&SELECTED)
         {txt = ObjcGetTxt(object, i);
          memcpy(pt, txt, 2);
          pt[2] = ' ';
          pt   += 3;
         }
     }
 for (i=TEXTE_SEG_TXT; i<=HEAP_SIZE_TXT; i++)
     {txt = ObjcGetTxt(object, i);
      if (*txt)
         {INT16 ind = i - TEXTE_SEG_TXT;
          ind     = ind<<2;   /* x 4 rapide   */
          memcpy(pt, " -T= -D= -B= -S= -H=" + ind , 4);  pt+=4;
          strcpy(pt, txt);                          pt+=strlen(pt);
         }
     }
 *pt = 0;

 if      (object[RAD_MEMPROTECT].ob_state&SELECTED)   MemMode = 'A';
 else if (object[RAD_MEMUNPROTECT].ob_state&SELECTED) MemMode = 'B';
 else if (object[RAD_SUPERVISEUR].ob_state&SELECTED)  MemMode = 'C';
 else if (object[RAD_READONLY].ob_state&SELECTED)     MemMode = 'D';
 
 SharedTxt = object[CHK_SHARED_TXT].ob_state&SELECTED;

 CleanArg(option);
 object = GETWINDTREE(wind_targ);
 ObjcSetTxt(object, P2I_LINK_OPT_TXT, option);
 SaveDefConf(wind_targ);
 if ((object[ONG_GCCSHELL].ob_flags&HIDETREE))
      Wobjc_draw(wind_targ, object, P2I_LINK_OPT_TXT, 1, 0);
}

/*----------------------- DialogToCompilParam -----------------------------*/
void DialogToCompilParam(OBJECT *object, char *option)
{INT16 i;
 char *txt      = 0;
 char *pt       = option;
 INT16  wind_targ = IdentToIndice(W_PCSTUDIO);
 *pt   = 0; 
 for (i=CHK_ANSI_KEYW; i<=CHK_COPRO_CODE; i++)
     {if (object[i].ob_state&SELECTED)
         {txt = ObjcGetTxt(object, i);
          memcpy(pt, txt, 2);
          pt[2] = ' ';
          pt   += 3;
         }
     }

 txt = ObjcGetTxt(object, NBR_ERREURS_TXT);
 if (*txt)
    {strcpy(pt, " -E");  pt+=3;
     strcpy(pt, txt);    pt+=strlen(pt);
    }
 txt = ObjcGetTxt(object, NBR_WARNING_TXT);
 if (*txt)
    {strcpy(pt, " -F");  pt+=3;
     strcpy(pt, txt);    pt+=strlen(pt);
    }
 txt = ObjcGetTxt(object, NRR_CAR_IDEN_TXT);
 if (*txt)
    {strcpy(pt, " -L");  pt+=3;
     strcpy(pt, txt);    pt+=strlen(pt);
    }
 txt = ObjcGetTxt(object, NBR_LEVEL_TXT);
 strcpy(pt, " -W");  pt+=3;
 if (*txt)
    {strcpy(pt, txt);    pt+=strlen(pt);
    }
 txt = ObjcGetTxt(object, MACRO_COMPIL_TXT);
 if (*txt)
    {strcpy(pt, " -D");  pt+=3;
     strcpy(pt, txt);    pt+=strlen(pt);
    }
 txt = ObjcGetTxt(object, OUT_COMPIL_TXT);
 if (*txt)
    {strcpy(pt, " -N");  pt+=3;
     strcpy(pt, txt);    pt+=strlen(pt);
    }
 
 *pt = 0;
 CleanArg(option);
 object = GETWINDTREE(wind_targ);
 ObjcSetTxt(object, P2I_COMP_OPT_TXT, option);
 SaveDefConf(wind_targ);
 if ((object[ONG_GCCSHELL].ob_flags&HIDETREE))
      Wobjc_draw(wind_targ, object, P2I_COMP_OPT_TXT, 1, 0);
}

/*----------------------- DialogToAsemblParam -----------------------------*/
void DialogToAsemblParam(OBJECT *object,  char *option)
{INT16 i;
 char *txt      = 0;
 char *pt       = option;
 INT16  wind_targ = IdentToIndice(W_PCSTUDIO);
 
 *pt   = 0; 
 for (i=CHK_MC68010; i<=CHK_NOOUTPUTMESS; i++)
     {if (object[i].ob_state&SELECTED)
         {char *txt = ObjcGetTxt(object, i);
          memcpy(pt, txt, 2);
          pt[2] = ' ';
          pt   += 3;
         }
     }
 txt = ObjcGetTxt(object, MACRO_ASM_TXT);
 if (*txt)
    {strcpy(pt, " -D");  pt+=3;
     strcpy(pt, txt);    pt+=strlen(pt);
    }
 txt = ObjcGetTxt(object, OUTPUT_ASM_TXT);
 if (*txt)
    {strcpy(pt, " -N");  pt+=3;
     strcpy(pt, txt);    pt+=strlen(pt);
    }
 txt = ObjcGetTxt(object, INCLUDE_ASM_TXT);
 if (*txt)
    {strcpy(pt, " -I");  pt+=3;
     strcpy(pt, txt);    pt+=strlen(pt);
    }
 *pt = 0;
 CleanArg(option);
 object = GETWINDTREE(wind_targ);
 ObjcSetTxt(object, P2I_ASM_OPT_TXT, option);
 SaveDefConf(wind_targ);
 if ((object[ONG_GCCSHELL].ob_flags&HIDETREE))
      Wobjc_draw(wind_targ, object, P2I_ASM_OPT_TXT, 1, 0);
}

/*------------------ OptionCompilToDialog ---------------------------------*/
void OptionCompilToDialog(INT16 w_ind, OBJECT *object, char *options, INT16 redraw_flag)
{char *pt =  options;
 char arg[256];
 INT16 i;
 /*......... tout deselectionner ............*/
 for (i=CHK_ANSI_KEYW; i<=CHK_COPRO_CODE; i++)
     {object[i].ob_state &=  ~SELECTED;
     }
 /*......... analyse des arguments ..........*/
 /*          et selectionner les             */
 /*          boutons correspondant           */
 /*          aux arguments.                  */
 while (*pt)
   {if (*pt==' ') 
       {pt++;
       }
    else
       {char *pt_arg = arg;
        while (*pt && *pt != ' ')
              {*pt_arg = *pt;
               pt_arg++;
               pt++;
              }
        *pt_arg = 0; strupr(arg);
        if      (arg[1]=='E')
           {ObjcSetTxt(object, NBR_ERREURS_TXT, arg+2);
            if (redraw_flag)  Wobjc_draw(w_ind, object, NBR_ERREURS_TXT, 1, 0);
           }
        else if (arg[1]=='F')
           {ObjcSetTxt(object, NBR_WARNING_TXT, arg+2);
            if (redraw_flag)  Wobjc_draw(w_ind, object, NBR_WARNING_TXT, 1, 0);
           }
        else if (arg[1]=='L')
           {ObjcSetTxt(object, NRR_CAR_IDEN_TXT, arg+2);
            if (redraw_flag)  Wobjc_draw(w_ind, object, NRR_CAR_IDEN_TXT, 1, 0);
           }
        else if (arg[1]=='W')
           {ObjcSetTxt(object, NBR_LEVEL_TXT, arg+2);
            if (redraw_flag)  Wobjc_draw(w_ind, object, NBR_LEVEL_TXT, 1, 0);
           }
        else if (arg[1]=='N')
           {ObjcSetTxt(object, OUT_COMPIL_TXT, arg+2);
            if (redraw_flag)  Wobjc_draw(w_ind, object, OUT_COMPIL_TXT, 1, 0);
           }
        else if (arg[1]=='D')
           {ObjcSetTxt(object, MACRO_COMPIL_TXT, arg+2);
            if (redraw_flag)  Wobjc_draw(w_ind, object, MACRO_COMPIL_TXT, 1, 0);
           }
        else
           {for (i=CHK_ANSI_KEYW; i<=CHK_COPRO_CODE; i++)
                {char *txt = ObjcGetTxt(object, i);
                 char ob_arg[3]; memcpy(ob_arg, txt, 2); ob_arg[2] = 0; strupr(ob_arg);
                 if (strcmp(ob_arg, arg)==0)
                    {object[i].ob_state |= SELECTED;
                    /* ObjcSetTxt(object, PRM_DIAL_PRM_WCONTROL_ONG_ACTIF,  itoa(WcontrolOngActif+1,buft,10));*/
                    }
                 if (redraw_flag)  Wobjc_draw(w_ind, object, i, 1, 0);
                } /* endfor (i=CHK_ANSI_KEYW; i<=CHK_COPRO_CODE; i++) */
          } /* end else if (pt_arg[1]=='W') */
       } /* endelse */
   } /*end while (*pt) */
}

/*------------------ OptionAsemblToDialog ---------------------------------*/
void OptionAsemblToDialog(INT16 w_ind, OBJECT *object, char *options, INT16 redraw_flag)
{char *pt =  options;
 char arg[256];
 INT16 i;
 /*......... tout deselectionner ............*/
 for (i=CHK_MC68010; i<=CHK_NOOUTPUTMESS; i++)
     {object[i].ob_state &=  ~SELECTED;
     }
 /*......... analyse des arguments ..........*/
 /*          et selectionner les             */
 /*          boutons correspondant           */
 /*          aux arguments.                  */
 while (*pt)
   {if (*pt==' ') 
       {pt++;
       }
    else
       {char *pt_arg = arg;
        while (*pt && *pt != ' ')
              {*pt_arg = *pt;
               pt_arg++;
               pt++;
              }
        *pt_arg = 0; strupr(arg);
        if (arg[1]=='I')
           {ObjcSetTxt(object, INCLUDE_ASM_TXT, arg+2);
            if (redraw_flag)  Wobjc_draw(w_ind, object, INCLUDE_ASM_TXT, 1, 0);
           }
        else if (arg[1]=='N')
           {ObjcSetTxt(object, OUTPUT_ASM_TXT, arg+2);
            if (redraw_flag)  Wobjc_draw(w_ind, object, OUTPUT_ASM_TXT, 1, 0);
           }
        else if (arg[1]=='D')
           {ObjcSetTxt(object, MACRO_ASM_TXT, arg+2);
            if (redraw_flag)  Wobjc_draw(w_ind, object, MACRO_ASM_TXT, 1, 0);
           }
        else
           {for (i=CHK_MC68010; i<=CHK_NOOUTPUTMESS; i++)
                {char *txt = ObjcGetTxt(object, i);
                 char ob_arg[3]; memcpy(ob_arg, txt, 2); ob_arg[2] = 0; strupr(ob_arg);
                 if (strcmp(ob_arg, arg)==0)
                    {object[i].ob_state |= SELECTED;
                    /* ObjcSetTxt(object, PRM_DIAL_PRM_WCONTROL_ONG_ACTIF,  itoa(WcontrolOngActif+1,buft,10));*/
                    }
                 if (redraw_flag)  Wobjc_draw(w_ind, object, i, 1, 0);
                } /* endfor (i=CHK_ANSI_KEYW; i<=CHK_COPRO_CODE; i++) */
          } /* end else if (pt_arg[1]=='W') */
       } /* endelse */
   } /*end while (*pt) */
}

/*------------------ OptionLinkerToDialog ---------------------------------*/
void OptionLinkerToDialog(INT16 w_ind, OBJECT *object, char *options, INT16 redraw_flag)
{char *pt =  options;
 char arg[256];
 INT16 i;
 /*......... tout deselectionner ............*/
 for (i=CHK_LNKADDGLOBAL; i<=CHK_LNK_NOOUTPUT; i++)
     {object[i].ob_state &=  ~SELECTED;
     }
 for (i=RAD_MEMPROTECT; i<=RAD_READONLY; i++)
     {object[i].ob_state &=  ~SELECTED;
     }
 switch(MemMode)
    {case 'A': object[RAD_MEMPROTECT].ob_state    |= SELECTED; break;
     case 'B': object[RAD_MEMUNPROTECT].ob_state  |= SELECTED; break;
     case 'C': object[RAD_SUPERVISEUR].ob_state   |= SELECTED; break;
     case 'D': object[RAD_READONLY].ob_state      |= SELECTED; break;
    }
 if (SharedTxt)   object[CHK_SHARED_TXT].ob_state |=  SELECTED;
 else             object[CHK_SHARED_TXT].ob_state &= ~SELECTED;
 /*......... analyse des arguments ..........*/
 /*          et selectionner les             */
 /*          boutons correspondant           */
 /*          aux arguments.                  */
 while (*pt)
   {if (*pt==' ') 
       {pt++;
       }
    else
       {char *pt_arg = arg;
        while (*pt && *pt != ' ')
              {*pt_arg = *pt;
               pt_arg++;
               pt++;
              }
        *pt_arg = 0; strupr(arg);
        if (arg[1]=='S')
           {ObjcSetTxt(object, STACT_SIZE_TXT, arg+3);
            if (redraw_flag)  Wobjc_draw(w_ind, object, STACT_SIZE_TXT, 1, 0);
           }
        else if (arg[1]=='T')
           {ObjcSetTxt(object, TEXTE_SEG_TXT, arg+3);
            if (redraw_flag)  Wobjc_draw(w_ind, object, TEXTE_SEG_TXT, 1, 0);
           }
        else if (arg[1]=='D')
           {ObjcSetTxt(object, DATA_SEG_TXT, arg+3);
            if (redraw_flag)  Wobjc_draw(w_ind, object, DATA_SEG_TXT, 1, 0);
           }
        else if (arg[1]=='B')
           {ObjcSetTxt(object, BSS_SEG_TXT, arg+3);
            if (redraw_flag)  Wobjc_draw(w_ind, object, BSS_SEG_TXT, 1, 0);
           }
        else if (arg[1]=='H')
           {ObjcSetTxt(object, HEAP_SIZE_TXT, arg+3);
            if (redraw_flag)  Wobjc_draw(w_ind, object, HEAP_SIZE_TXT, 1, 0);
           }
        else
           {for (i=CHK_LNKADDGLOBAL; i<=CHK_LNK_NOOUTPUT; i++)
                {char *txt = ObjcGetTxt(object, i);
                 char ob_arg[3]; memcpy(ob_arg, txt, 2); ob_arg[2] = 0; strupr(ob_arg);
                 if (strcmp(ob_arg, arg)==0)
                    {object[i].ob_state |= SELECTED;
                    /* ObjcSetTxt(object, PRM_DIAL_PRM_WCONTROL_ONG_ACTIF,  itoa(WcontrolOngActif+1,buft,10));*/
                    }
                 if (redraw_flag)  Wobjc_draw(w_ind, object, i, 1, 0);
                } /* endfor (i=CHK_ANSI_KEYW; i<=CHK_COPRO_CODE; i++) */
          } /* end else if (pt_arg[1]=='W') */
       } /* endelse */
   } /*end while (*pt) */
}