/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\   MEN_FUNC.C    \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/* Ce module est un des sources C de : PCSTUDIO.PRG                    */
/* Le fichier projet associ est:      PCSTUDIO.PRJ                    */
/* Gestion des menus et raccourcis claviers:                           */

 
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*--------------------- INCLUDES DES AUTRES MODULES DU PROGRAMME -------*/
#include <EAZY_GEM.H>  /* inclure les definitions des fonctions que le  */

/*--------------------- INCLURE LES DEFINITIONS SYMBOLIQUES ------------*/
/*                      que l'diteur de ressource gnre               */
/*                      lors de la cration de la ressource             */
#include "PCSTUDIO.SYS\SHORTCUT.H"
/*.................. structure de raccourci clavier ...................*/
/*                   associe un  etat  du clavier                     */
/*                     une fonction du programme                       */
 typedef struct
       {INT16 ksp;       /* etat des touches ALT, SHIFT, CONTROL         */
        INT16 key;       /* scancode si negatif/ code ASCII si positif   */
        INT16 Func;      /* numero de la fonction programme a executer   */
       } SHORT_CUT;
/*.................. table des raccourcis possibles ...................*/
/*                         avec leur definition                        */
/*............ Fonctions d'EZ_EDIT ....................................*/


SHORT_CUT ShortCut[31] = {  {K_CTRL,         'O', PRJ_CHARGER},        /* 1  */
                            {K_CTRL,         'S', PRJ_SAUVER},         /* 2  */
                            {K_CTRL_SHIFT,   'S', PRJ_SAUVER_SOUS},    /* 3  */
                            {K_CTRL_SHIFT,   'F', PRJ_ADD_TOLIST},     /* 4  */
                            {K_CTRL_SHIFT,   'T', PRJ_SUB_TOLIST},     /* 5  */
                            {K_CTRL,         'F', PRJ_LOADFROMLIST},   /* 6  */
                            {K_CTRL,         'Q', PRJ_QUIT},           /* 7  */
                            {K_CTRL_SHIFT,   'Q', PRJ_QUIT_EDIT},      /* 8  */
                            {K_CTRL,         'E', PRJ_EDIT_SRC},       /* 9  */
                            {K_CTRL,         'G', PRJ_EDIT_RSC},       /* 10 */
                            {K_CTRL,         '+', PRJ_ADD_COM},        /* 11 */
                            {K_CTRL,         'K', PRJ_ALL_COMPIL},     /* 12 */
                            {K_CTRL_SHIFT,   'K', PRJ_ALL_COMPLINK},   /* 13 */
                            {K_CTRL,         'M', PRJ_UPD_COMP},       /* 14 */
                            {K_CTRL_SHIFT,   'M', PRJ_UPD_COMPLINK},   /* 15 */
                            {K_CTRL,         'L', PRJ_LINK},           /* 16 */
                            {K_CTRL,         -98, PRJ_HELP_COMP},      /* 17 */
                            {K_CTRL_SHIFT,   -98, PRJ_HELP_LINK},      /* 18 */
                            {K_CTRL_SHIFT,   'D', PRJ_DEBUG},          /* 19 */
                            {K_CTRL,         'D', PRJ_UPD_DEBUG},      /* 20 */
                            {K_CTRL_SHIFT,   'R', PRJ_RUN},            /* 21 */
                            {K_CTRL,         'R', PRJ_UPD_RUN},        /* 22 */
                            {K_CTRL,         'Y', PRJ_OPT_COMP},       /* 23 */
                            {K_CTRL,         'J', PRJ_OPT_ASM},        /* 24 */
                            {K_CTRL,         'H', PRJ_OPT_LINK},       /* 25 */
                            {0,              -98, PRJ_HELP},           /* 26 */
                            {K_CTRL,         'I', PRJ_INFO},           /* 27 */
                            {K_CTRL,         '%', PRJ_MAK_FULL_ARCHIV},/* 28 */
                            {K_CTRL_SHIFT,   '%', PRJ_MAK_DIST_ARCHIV},/* 29 */
                            {0,              ' ', PRJ_LIST_FNC}
                           };

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                         TYPAGE DES FENETRES                          */
/*----------------------------------------------------------------------*/
 
#define W_PCSTUDIO    1     /* (identificateur ou type) de la Fenetre   */
#define W_CONFIG      2     /* (identificateur ou type) de la Fenetre   */
#define W_PEXEC3      3     /* (identificateur ou type) de la Fenetre   */
#define W_WINDLIST    4     /* (identificateur ou type) de la Fenetre   */


/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
extern char **TxtPtStrMess;

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*................ FONCTIONs DU FICHIER ACTUEL .........................*/
void  RaccFileToCfg(char *path, char *name);
void  RaccStrToShortCut(INT16 num_func, char *racc);
void  InstalleRaccInMenu(OBJECT *object);
INT16   IsKeyShortCut(INT16 ksp, INT16 key);
INT16   RaccToMenuStr(OBJECT *object, INT16 num_func, INT16 ksp, INT16 key);
char *ShortCutToStr(char *dst, INT16 ksp, INT16 key);
char *EndOfLine(char *pt);
char *FromEndGetArg(char *txt, char *pt, char *str_cpy);
INT16   StrMenuToShortCut(char *txt, INT16 *key, INT16 *ksp);
/*................ fonction du fichier PCSTUDIO.C ......................*/
extern INT16   ExeCommande(INT16 com);
extern char *NextLine(char *pt);
extern char *GoFirstValid(char *pt, char *tojump);
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*----------------------- RaccFileToCfg ----------------------------------*/
/* ACTION: charge si il existe le fichier de configuration des raccourcis */
/*         clavier, et l'installe dans les raccourcis,                    */
void RaccFileToCfg(char *path, char *name)
{long   len_cfg = 0;
 char *config   = 0;
 char       *pt = 0;
 long     line  = 0;
 char arg[128];
 char racc[128];
 /*........... charger fichier de config si existe .......................*/
 len_cfg = Fic_exist(path, name);
 if (len_cfg<10) return;
 config  = malloc(len_cfg+2);
 if (config==0)  return;
 Bload(path, name, config);
 config[len_cfg] = 0;
 /*............. analyse et mise a jour des raccourcis ....................*/
 pt = config;
 while (*pt)
  {pt=GoFirstValid(pt, " \n\r\t");
   if      (*pt==';') {pt = NextLine(pt); line++;}
   else if (*pt>='0' && *pt<='9')
      {pt     = GetArgument(pt, arg) ;
       if (pt) 
          {char sav;
           /*... fin peut etre soit le commentaire ';' soit fin de ligne ...*/
           char *pt_end = strchr(pt,';');
           if (pt_end==0) pt_end  = EndOfLine(pt);
           sav = *pt_end; *pt_end = 0;
           strcpy(racc, pt); 
           /*.......... attention modifie racc ...........*/
           RaccStrToShortCut(atoi(arg), racc);
           if (pt_end) {*pt_end = sav;}
           pt = NextLine(pt);
           line++;
          }
       else    
          {free(config);
           return;
          }
      }
   else pt++;
  }
 free(config);
}
/*--------------------------- EndOfLine ---------------------------------*/
char *EndOfLine(char *pt)
{while (*pt &&  *pt != 13 && *pt != 10)  pt++;
return pt;
}
/*----------------------- RaccStrToShortCut --------------------------------*/
void RaccStrToShortCut(INT16 num_func, char *racc)
{INT16 key, ksp;
 INT16 nb_short_cut    = (INT16)(sizeof(ShortCut)/sizeof(SHORT_CUT));
 INT16 ptShortCut      = 0;
 /*........ rechercher le raccourci lie a ce numero de fonction ....*/
 for (ptShortCut = 0; ptShortCut<nb_short_cut; ptShortCut++)
     {if      (ShortCut[ptShortCut].Func == num_func) break;
     }
 if (ptShortCut >= nb_short_cut)                         return;
 /*........ chaine raccourci vers touches ..........................*/
 racc = StrTrimDeb(racc);
 StrTrimEnd(racc);
 StrMenuToShortCut(racc, &key, &ksp);
 /*........ y placer le raccourci clavier donn en entree ..........*/
 ShortCut[ptShortCut].ksp = ksp;
 ShortCut[ptShortCut].key = key;
}
/*------------------ StrMenuToShortCut ---------------------------------*/
INT16 StrMenuToShortCut(char *txt, INT16 *key, INT16 *ksp)
{char *pt         = txt + strlen(txt); 
 char pt_car[64];
 char pt_fst_key[64];
 char pt_scd_key[64];
 *ksp    = 0;
 *key    = 0;
 /*........... extraire les mots en partant de la fin .........*/
 pt = FromEndGetArg(txt, pt, pt_car);
 pt = FromEndGetArg(txt, pt, pt_fst_key);
 pt = FromEndGetArg(txt, pt, pt_scd_key);
 /*........... analyse des resultats ..........................*/
 if      (strcmp(pt_car, "HELP")==0)   *key = -98;
 else if (strcmp(pt_car, "UNDO")==0)   *key = -97;
 else if (strcmp(pt_car, "HOME")==0)   *key = -71;
 else if (strcmp(pt_car, "INSRT")==0)  *key = -82;
 else if (strcmp(pt_car, "F1")==0)     *key = -59;
 else if (strcmp(pt_car, "F2")==0)     *key = -60;
 else if (strcmp(pt_car, "F3")==0)     *key = -61;
 else if (strcmp(pt_car, "F4")==0)     *key = -62;
 else if (strcmp(pt_car, "F5")==0)     *key = -63;
 else if (strcmp(pt_car, "F6")==0)     *key = -64;
 else if (strcmp(pt_car, "F7")==0)     *key = -65;
 else if (strcmp(pt_car, "F8")==0)     *key = -66;
 else if (strcmp(pt_car, "F9")==0)     *key = -67;
 else if (strcmp(pt_car, "F10")==0)    *key = -68;
 else if (strcmp(pt_car, "DEL")==0)    *key = ''; 
 else if (strcmp(pt_car, "BACK")==0)   *key = '';
 else if (strcmp(pt_car, "SPACE")==0)  *key = ' ';
 else if (strcmp(pt_car, "TAB")==0)    *key = 9;
 else if (strcmp(pt_car, "RETURN")==0) *key = 13;
 else if (strcmp(pt_car, "ESC")==0)    *key = 27;
 else                                  *key = (*pt_car);
 
 if (*pt_fst_key)
    {if      (strcmp(pt_fst_key, "CTRL")==0)  *ksp |= K_CTRL;
     else if (strcmp(pt_fst_key, "ALT")==0)   *ksp |= K_ALT;
     else if (strcmp(pt_fst_key, "SHIFT")==0) *ksp |= K_LRSHIFT;
    }
 if (*pt_scd_key)
    {if      (strcmp(pt_scd_key, "CTRL")==0)  *ksp |= K_CTRL;
     else if (strcmp(pt_scd_key, "ALT")==0)   *ksp |= K_ALT;
     else if (strcmp(pt_scd_key, "SHIFT")==0) *ksp |= K_LRSHIFT;
    }
 
 return 1;
}

/*----------------------- FromEndGetArg -----------------------------------*/
char *FromEndGetArg(char *txt, char *pt, char *str_cpy)
{char *pt_end;
 char sav_car;
 
 *str_cpy = 0;
 if (pt[-1]==' ')  while(pt>txt && pt[-1]==' ') pt--;
 pt_end = pt;
 while(pt>txt && pt[-1] != ' ') pt--;
 if (pt_end>pt)
    {sav_car = *pt_end;
     *pt_end = 0;
     strcpy(str_cpy, pt);
     *pt_end = sav_car;
    }
 return pt;
}

/*----------------------- InstalleRaccInMenu ----------------------------*/
void InstalleRaccInMenu(OBJECT *object)
{INT16 nb_short_cut    = (INT16)(sizeof(ShortCut)/sizeof(SHORT_CUT));
 INT16            i    = 0;
 if (object==0)        return ;
 for (i = 0; i<nb_short_cut; i++)
     {RaccToMenuStr(object, ShortCut[i].Func, ShortCut[i].ksp, ShortCut[i].key);
     }
}
/*----------------------- RaccToMenuStr --------------------------------*/
INT16 RaccToMenuStr(OBJECT *object, INT16 num_func, INT16 ksp, INT16 key)
{INT16 ind      = -1;
 long len_str = 0;
 char raccStr[64];
 do
   {ind ++;          
    if ( object[ind].ob_type == G_STRING)
       {char *men_str = object[ind].ob_spec.free_string;
        char *pt_fnc  = strchr(men_str, '|');
        
        if (pt_fnc)
           {INT16 num_fnc = atoi(pt_fnc+1);
            if (num_fnc == num_func) 
               {ShortCutToStr(raccStr, ksp, key);
                len_str = strlen(raccStr);
                if (pt_fnc - men_str > len_str)
                   {memcpy(pt_fnc - len_str, raccStr, len_str);
                   }
                return ind;
               }
           }
        
       }
   } while( ! (object[ind].ob_flags & LASTOB));
return 0;
}
/*----------------------- ShortCutToStr --------------------------------*/
char *ShortCutToStr(char *dst, INT16 ksp, INT16 key)
{char *car = " ";
 *dst      = 0;
 *car      = (char)key;
 if (ksp & K_LRSHIFT) strcat(dst, "SHIFT ");
 if (ksp & K_CTRL)    strcat(dst, "CTRL ");
 if (ksp & K_ALT)     strcat(dst, "ALT ");
 
 if (key<0)
    {switch (key)
      {case  -98: strcat(dst, "HELP");  break;
       case  -97: strcat(dst, "UNDO");  break;
       case  -71: strcat(dst, "HOME");  break;
       case  -82: strcat(dst, "INSRT"); break;
       case  -59: strcat(dst, "F1");    break;
       case  -60: strcat(dst, "F2");    break;
       case  -61: strcat(dst, "F3");    break;
       case  -62: strcat(dst, "F4");    break;
       case  -63: strcat(dst, "F5");    break;
       case  -64: strcat(dst, "F6");    break;
       case  -65: strcat(dst, "F7");    break;
       case  -66: strcat(dst, "F8");    break;
       case  -67: strcat(dst, "F9");    break;
       case  -68: strcat(dst, "F10");   break;
      }
    }
 else if (key=='')  strcat(dst, "DEL");
 else if (key=='')  strcat(dst, "BACK");
 else if (key==' ')  strcat(dst, "SPACE");
 else if (key=='9')  strcat(dst, "TAB");
 else if (key=='13') strcat(dst, "RETURN");
 else if (key=='27') strcat(dst, "ESC");
 else                strcat(dst,car);
 return dst;
}

/*--------------------------- IsKeyShortCut -------------------------------*/
INT16 IsKeyShortCut(INT16 ksp, INT16 key)
{INT16 nb_short_cut    = (INT16)(sizeof(ShortCut)/sizeof(SHORT_CUT));
 INT16 car;
 INT16 i;
 INT16 ksp_ok;
 
 /*........... si Scan code uniquement ..............*/
 /*            (poids faible vide)                   */
 /*            il s'agit des touches de controle     */
 if ((key&0x00FF)==0)
    {key = key>>8;
     switch(key)
        {case 98:   /* "HELP" */ 
         case 97:   /* "UNDO" */ 
         case 71:   /* "HOME" */ 
         case 82:   /* "INS"  */ 
         case 59:   /* "F1"   */ 
         case 60:   /* "F2"   */ 
         case 61:   /* "F3"   */ 
         case 62:   /* "F4"   */ 
         case 63:   /* "F5"   */ 
         case 64:   /* "F6"   */ 
         case 65:   /* "F7"   */ 
         case 66:   /* "F8"   */ 
         case 67:   /* "F9"   */ 
         case 68:   /* "F10"  */ 
              car = -(key);
              break;
        }
    } /* endif if (key&0xFF00)  */
 /*............... sinon code clavier en plus .........*/
 else
    {car = ScanToAscii(key&0xFF00, ksp) ;
    }
   
 for (i=0; i<nb_short_cut; i++)
     {
      if      (ShortCut[i].ksp == K_CTRL_SHIFT && (ksp&K_CTRL))  ksp_ok = ksp & K_LRSHIFT;
      else if (ShortCut[i].ksp == K_LRSHIFT)                     ksp_ok = ksp & K_LRSHIFT;
      else if (ShortCut[i].ksp == ksp)                           ksp_ok = 1;
      else                                                       ksp_ok = 0;
      if (ShortCut[i].key == car && ksp_ok) return ShortCut[i].Func;
     }
 return 0;
}

